2016年5月15日 星期日

Python 研究-深入理解yield


Python 深入理解yield

yield的英文單詞意思是生產,剛接觸Python的時候感到非常困惑,一直沒弄明白yield的用法。
只是粗略的知道yield可以用來為一個函數返回值塞資料,比如下面的例子:
def addlist(alist):
    for i in alist:
        yield i + 1
取出alist的每一項,然後把i + 1塞進去。然後通過呼叫取出每一項:
alist = [1, 2, 3, 4]
for x in addlist(alist):
    print x,
這的確是yield套用的一個例子,但是,看過limodou的文章《2.5版yield之學習心得》,並自己反覆體驗後,對yield有了一個全新的理解。
1. 包含yield的函數
假如你看到某個函數包含了yield,這意味著這個函數已經是一個Generator,它的執行會和其他普通的函數有很多不同。比如下面的簡單的函數:
def h():
    print 'To be brave'
    yield 5

h()
可以看到,呼叫h()之後,print 語句並沒有執行!這就是yield,那麼,如何讓print 語句執行呢?這就是後面要討論的問題,通過後面的討論和學習,就會明白yield的工作原理了。
2. yield是一個表達式
Python2.5以前,yield是一個語句,但現在2.5中,yield是一個表達式(Expression),比如:
m = yield 5
表達式(yield 5)的返回值將賦值給m,所以,認為 m = 5 是錯誤的。那麼如何獲取(yield 5)的返回值呢?需要用到後面要介紹的send(msg)方法。
3. 透過next()語句看原理
現在,我們來揭曉yield的工作原理。我們知道,我們上面的h()被呼叫後並沒有執行,因為它有yield表達式,因此,我們通過next()語句讓它執行。next()語句將恢復Generator執行,並直到下一個yield表達式處。比如:
def h():
    print 'Wen Chuan'
    yield 5
    print 'Fighting!'

c = h()
c.next()
c.next()呼叫後,h()開始執行,直到遇到yield 5,因此輸出結果:
Wen Chuan
當我們再次呼叫c.next()時,會繼續執行,直到找到下一個yield表達式。由於後面沒有yield了,因此會拋出異常:
Wen Chuan
Fighting!
Traceback (most recent call last):
  File "/home/evergreen/Codes/yidld.py", line 11, in <module>
    c.next()
StopIteration
4. send(msg) 與 next()
瞭解了next()如何讓包含yield的函數執行後,我們再來看另外一個非常重要的函數send(msg)。其實next()和send()在一定意義上作用是相似的,區別是send()可以傳遞yield表達式的值進去,而next()不能傳遞特定的值,只能傳遞None進去。因此,我們可以看做
c.next() 和 c.send(None) 作用是一樣的。
來看這個例子:
def h():
    print 'Wen Chuan',
    m = yield 5  # Fighting!
    print m
    d = yield 12
    print 'We are together!'

c = h()
c.next()  #相當於c.send(None)
c.send('Fighting!')  #(yield 5)表達式被賦予了'Fighting!'
輸出的結果為:
Wen Chuan Fighting!
需要提醒的是,第一次呼叫時,請使用next()語句或是send(None),不能使用send發送一個非None的值,否則會出錯的,因為沒有yield語句來接收這個值。
5. send(msg) 與 next()的返回值
send(msg) 和 next()是有返回值的,它們的返回值很特殊,返回的是下一個yield表達式的參數。比如yield 5,則返回 5 。到這裡,是不是明白了一些什麼東西?本文第一個例子中,通過for i in alist 迭代 Generator,其實是每次都呼叫了alist.Next(),而每次alist.Next()的返回值正是yield的參數,即我們開始認為被壓進去的東東。我們再延續上面的例子:
def h():
    print 'Wen Chuan',
    m = yield 5  # Fighting!
    print m
    d = yield 12
    print 'We are together!'

c = h()
m = c.next()  #m 獲取了yield 5 的參數值 5
d = c.send('Fighting!')  #d 獲取了yield 12 的參數值12
print 'We will never forget the date', m, '.', d
輸出結果:
Wen Chuan Fighting!
We will never forget the date 5 . 12
6. throw() 與 close()中斷 Generator
中斷Generator是一個非常靈活的技巧,可以通過throw拋出一個GeneratorExit異常來終止Generator。Close()方法作用是一樣的,其實內部它是呼叫了throw(GeneratorExit)的。我們看:
def close(self):
    try:
        self.throw(GeneratorExit)
    except (GeneratorExit, StopIteration):
        pass
    else:
        raise RuntimeError("generator ignored GeneratorExit")
# Other exceptions are not caught
因此,當我們呼叫了close()方法後,再呼叫next()或是send(msg)的話會拋出一個異常:
Traceback (most recent call last):
  File "/home/evergreen/Codes/yidld.py", line 14, in <module>
    d = c.send('Fighting!')  #d 獲取了yield 12 的參數值12
StopIteration

註:以上觀點屬於本人的個人理解,如有偏差請批評指正。謝謝!

沒有留言:

張貼留言